From b2305eaab95b7cf37cfb9331350c87e523ba9ede Mon Sep 17 00:00:00 2001
From: Rong Yan <rongyan236@foxmail.com>
Date: Mon, 20 Jul 2015 23:18:09 -0500
Subject: [PATCH 5/6] common/ppc/dct.c: POWER LE support in
 x264_add4x4_idct_altivec() ALTIVEC_STORE4_SUM_CLIP() add macro GET_DST16()

---
 common/ppc/dct.c | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

diff --git a/common/ppc/dct.c b/common/ppc/dct.c
index 6e17dcb..8d68dbb 100644
--- a/common/ppc/dct.c
+++ b/common/ppc/dct.c
@@ -258,13 +258,18 @@ void x264_sub16x16_dct8_altivec( int16_t dct[4][64], uint8_t *pix1, uint8_t *pix
     va_u32 = vec_splat((vec_u32_t)va_u8, 0);         \
     vec_ste(va_u32, element, (uint32_t*)dst);
 
+#ifdef WORDS_BIGENDIAN
+#define GET_DST16() (vec_u16_t)vec_mergeh(zero_u8v, dstv)
+#else
+#define GET_DST16() (vec_u16_t)vec_mergeh(dstv, zero_u8v)
+#endif
 #define ALTIVEC_STORE4_SUM_CLIP(dest, idctv, perm_ldv)          \
 {                                                               \
     /* unaligned load */                                        \
     vec_u8_t lv = vec_ld(0, dest);                              \
     vec_u8_t dstv = vec_perm(lv, zero_u8v, (vec_u8_t)perm_ldv); \
     vec_s16_t idct_sh6 = vec_sra(idctv, sixv);                  \
-    vec_u16_t dst16 = (vec_u16_t)vec_mergeh(zero_u8v, dstv);    \
+    vec_u16_t dst16 = GET_DST16();                              \
     vec_s16_t idstsum = vec_adds(idct_sh6, (vec_s16_t)dst16);   \
     vec_u8_t idstsum8 = vec_s16_to_u8(idstsum);                 \
     /* unaligned store */                                       \
@@ -273,6 +278,7 @@ void x264_sub16x16_dct8_altivec( int16_t dct[4][64], uint8_t *pix1, uint8_t *pix
     vec_ste(bodyv, element, (uint32_t *)dest);                  \
 }
 
+
 void x264_add4x4_idct_altivec( uint8_t *dst, int16_t dct[16] )
 {
     vec_u16_t onev = vec_splat_u16(1);
@@ -384,7 +390,7 @@ void x264_add16x16_idct_altivec( uint8_t *p_dst, int16_t dct[16][16] )
     vec_u8_t lv = vec_ld( 7, dest );                           \
     vec_u8_t dstv   = vec_perm( hv, lv, (vec_u8_t)perm_ldv );  \
     vec_s16_t idct_sh6 = vec_sra(idctv, sixv);                 \
-    vec_u16_t dst16 = (vec_u16_t)vec_mergeh(zero_u8v, dstv);   \
+    vec_u16_t dst16 = GET_DST16();                             \
     vec_s16_t idstsum = vec_adds(idct_sh6, (vec_s16_t)dst16);  \
     vec_u8_t idstsum8 = vec_packsu(zero_s16v, idstsum);        \
     /* unaligned store */                                      \
-- 
2.1.4

